diff --git a/lib/hive.rb b/lib/hive.rb
index b22bfe0e3..de0cb93de 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -57,6 +57,10 @@ module Hive
       "hive-bot-stop" => 1,
       "hive-bot-reload" => 1,
       "hive-bot-install" => 1,
+      # Local managed web service status (`hive web status --json`).
+      "hive-web-status" => 1,
+      # One-shot local surface provisioning (`hive setup --json`).
+      "hive-setup" => 1,
       # File-backed dispatch request the bot writes for the daemon to
       # consume. One JSON file per pending request under the state-home
       # `dispatch_requests/` directory. See
@@ -536,6 +540,23 @@ module Hive
     end
   end
 
+  # `hive web install` mirrors the daemon/bot install outcome split: drift is
+  # a recoverable USAGE error (re-run with --force) while a service-manager
+  # failure (systemctl / launchctl) is SOFTWARE. Separate classes so the
+  # top-level rescue maps each surface independently while still producing
+  # the stable 64 / 70 exit codes automation branches on.
+  class WebInstallDriftError < Error
+    def exit_code
+      ExitCodes::USAGE
+    end
+  end
+
+  class WebInstallFailed < Error
+    def exit_code
+      ExitCodes::SOFTWARE
+    end
+  end
+
   # Raised by `hive run` when the stage's terminal marker is :error. The
   # runner itself succeeded — the agent recorded a task-level failure.
   # Distinct from StageError (which signals a runner bug / git failure).
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index cd8090689..02078492f 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -257,6 +257,44 @@ module Hive
       ).call
     end
 
+    desc "setup", "Provision and validate the local Hive install (deps → qmd → web bundle → daemon → enrollment → web service)"
+    long_desc <<~DESC
+      One-shot setup for the first-class LOCAL (non-Docker) install. Runs, in
+      order, with each step idempotent and fail-fast-with-fix-command:
+
+        1. Backend prompt — persist which agents to provision globally
+           (Claude / Codex / Pi). Non-TTY (--non-interactive / piped stdin)
+           uses the defaults.
+        2. Dependency check — ruby (3.4), git, tmux, gh (auth), claude,
+           codex, node/npm, sqlite3. External agent CLIs (gh/claude/codex)
+           are DIAGNOSE-ONLY: missing/unauth prints the exact fix command
+           and is reported blocked, never installed or authenticated.
+        3. Bootstrap Hive-owned deps — qmd (managed npm install) and the
+           web bundle (obtain + bundle the Rails app at the installed gem
+           version).
+        4. Daemon service — `hive daemon install --force` + a status/version
+           consistency probe.
+        5. Project enrollment — `hive init .` (or `hive daemon enable` for an
+           already-registered project).
+        6. Web service — `hive web install` + a deep health probe at
+           http://127.0.0.1:4567/health?deep=1.
+
+      With --json, emits a single hive-setup.v1 document. A non-zero exit
+      means a hard dependency is missing or a step failed; blocked external
+      CLIs are warnings, not failures (the local web UI works without them).
+
+      Exit codes: 0 success; 1 incomplete; 64 usage; 70 internal; 78 config.
+    DESC
+    option :non_interactive, type: :boolean, default: false,
+                             desc: "skip prompts and use the default backends"
+    def setup
+      require "hive/commands/setup"
+      Hive::Commands::Setup.new(
+        json: options[:json],
+        non_interactive: options[:non_interactive]
+      ).call
+    end
+
     desc "update", "Update hive via the install channel that installed it"
     long_desc <<~DESC
       Reads the install-channel marker written by the installer and delegates
@@ -1332,18 +1370,46 @@ module Hive
       ).call
     end
 
-    desc "web", "Run the hivebox web UI"
+    desc "web [SUBCOMMAND]", "Run the hivebox web UI (foreground) or manage the local web service (install/start/stop/status)"
+    long_desc <<~DESC
+      With no subcommand, boots the Rails web UI in the foreground and
+      replaces this process with the Rails server (default bind
+      web.bind / web.port — 127.0.0.1:4567). The app must exist on disk:
+      run `hive setup` to provision it into ~/.local/share/hive/web, run
+      from the hivebox Docker image, or set HIVEBOX_WEB_APP_DIR.
+
+      Subcommands manage a SEPARATE per-user service (systemd-user on
+      Linux, launchd on macOS), distinct from `hive daemon`:
+
+        install [--force]  (Re)write + enable the platform-native unit
+                           (hive-web.service / local.hive-web.plist).
+                           Without --force, refuses to overwrite a
+                           pre-existing unit and exits 64 (USAGE); with
+                           --force it backs up the prior file to
+                           <path>.bak-<UTC-stamp> and restarts.
+        start              Run the web server detached (pidfile at
+                           <state_home>/.web.pid).
+        stop               SIGTERM the running web server (idempotent).
+        status [--json]    running/pid/uptime + service install state.
+                           --json emits hive-web-status.v1.
+
+      Exit codes: 0 success; 1 web-not-running for `status` (scriptable
+      precondition probe); 64 USAGE for drift without --force / unknown
+      subcommand; 70 SOFTWARE for a service-manager failure; 75 TEMPFAIL
+      when `start` finds a live web server; 78 CONFIG for a refused
+      non-loopback bind under web.auth_mode=loopback.
+    DESC
     option :bind, type: :string, desc: "override web.bind"
     option :port, type: :numeric, desc: "override web.port"
-    def web
-      if options[:json]
+    option :force, type: :boolean, default: false,
+                   desc: "for install: overwrite an existing unit (saves <path>.bak)"
+    def web(subcommand = nil)
+      require "hive/commands/web"
+      if options[:json] && subcommand != "status"
         require "json"
-        message = "hive web has no JSON output (it runs a long-lived server). " \
-                  "Use 'hive status --json' for machine-readable task data."
-        # Mirror `hive tui`'s rejection: emit a structured error envelope (sans
-        # `schema`, since web has no registered hive-* schema) and raise
-        # InvalidTaskPath for the USAGE (64) exit code — parity with every
-        # other --json failure on this surface.
+        message = "hive web #{subcommand || '(foreground)'} has no JSON output " \
+                  "(the foreground server runs long-lived; only `hive web status --json` " \
+                  "emits an envelope)."
         puts JSON.generate(
           "ok" => false,
           "error_class" => "InvalidTaskPath",
@@ -1354,8 +1420,13 @@ module Hive
         raise Hive::InvalidTaskPath, message
       end
 
-      require "hive/commands/web"
-      Hive::Commands::Web.new(bind: options[:bind], port: options[:port]).call
+      Hive::Commands::Web.new(
+        subcommand,
+        bind: options[:bind],
+        port: options[:port],
+        force: options[:force],
+        json: options[:json]
+      ).call
     end
 
     desc "tui", "Open the live, keystroke-driven dashboard for every active task"
diff --git a/lib/hive/commands/daemon.rb b/lib/hive/commands/daemon.rb
index 6c91610b1..d15e9e159 100644
--- a/lib/hive/commands/daemon.rb
+++ b/lib/hive/commands/daemon.rb
@@ -371,6 +371,7 @@ module Hive
 
         if @json
           service_state = probe_service_state
+          consistency = consistency_payload(pid: running ? pid : nil)
           puts JSON.generate(
             "schema" => "hive-daemon-status",
             "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-daemon-status"),
@@ -383,6 +384,12 @@ module Hive
             "service_installed" => service_state["service_installed"],
             "service_enabled" => service_state["service_enabled"],
             "unit_path" => service_state["unit_path"],
+            # Binary-consistency guard (U5): the resolved binary the installer
+            # would write, the CLI version, and whether the installed unit and
+            # running process agree with both.
+            "binary" => consistency["binary"],
+            "binary_version" => consistency["binary_version"],
+            "consistent" => consistency["consistent"],
             # Agent-native parity with the TUI footer / bot push: expose the
             # update nudge so a programmatic caller can detect "behind" too.
             "current_version" => Hive::VERSION,
@@ -397,6 +404,16 @@ module Hive
         raise Hive::Error, "daemon not running" unless running
       end
 
+      # Read-only binary-consistency probe for the status envelope. Any
+      # failure degrades the three fields to null instead of raising out of
+      # the whole command (mirrors probe_service_state).
+      def consistency_payload(pid:)
+        require "hive/daemon/consistency"
+        Hive::Daemon::Consistency.new(pid: pid).probe
+      rescue StandardError
+        { "binary" => nil, "binary_version" => Hive::VERSION, "consistent" => nil }
+      end
+
       # Read-only autostart-state snapshot for the status envelope. A status
       # probe must never take down the running/pid reporting that precedes
       # it, so any failure degrades the three service fields to null (the
diff --git a/lib/hive/commands/daemon/service_installer.rb b/lib/hive/commands/daemon/service_installer.rb
index 02cda2fbf..5e0d2aac2 100644
--- a/lib/hive/commands/daemon/service_installer.rb
+++ b/lib/hive/commands/daemon/service_installer.rb
@@ -44,11 +44,14 @@ module Hive
           template = File.read(File.expand_path("../../../../examples/systemd/hive-daemon.service", __dir__))
           # systemd .service files are POSIX-shell-ish — escape the
           # resolved binary path so whitespace, `%`, or other special
-          # characters don't produce a malformed unit.
+          # characters don't produce a malformed ExecStart=. Environment=
+          # does NOT parse shell backslash/quote escaping, so HIVE_BIN keeps
+          # the RAW path (the daemon reads ENV["HIVE_BIN"] verbatim into an
+          # argv element; an escaped value would point at a nonexistent file).
           escaped = Shellwords.escape(resolved_binary)
           template
             .sub(/^ExecStart=.*$/, "ExecStart=#{escaped} daemon start")
-            .sub(/^Environment=HIVE_BIN=.*$/, "Environment=HIVE_BIN=#{escaped}")
+            .sub(/^Environment=HIVE_BIN=.*$/, "Environment=HIVE_BIN=#{resolved_binary}")
             .sub(/^Environment=PATH=.*$/, build_path_line)
         end
 
diff --git a/lib/hive/commands/service_installer/base.rb b/lib/hive/commands/service_installer/base.rb
index 04f9ba760..08701f865 100644
--- a/lib/hive/commands/service_installer/base.rb
+++ b/lib/hive/commands/service_installer/base.rb
@@ -126,6 +126,15 @@ module Hive
           nil
         end
 
+        # Public accessor for the resolved binary the installer would bake into
+        # the unit. The daemon consistency guard (Hive::Daemon::Consistency)
+        # compares the installed unit and the running process against this, so
+        # drift detection reuses the exact resolution the installer writes
+        # (brew stable symlink → binary_path → PATH → source fallback).
+        def resolved_binary
+          resolve_binary
+        end
+
         private
 
         def install_macos!(autostart:, force:)
@@ -305,7 +314,7 @@ module Hive
           nil
         end
 
-        def resolved_binary
+        def resolve_binary
           if (brew_binary = homebrew_stable_binary)
             return File.expand_path(brew_binary)
           end
diff --git a/lib/hive/commands/setup.rb b/lib/hive/commands/setup.rb
new file mode 100644
index 000000000..4931df62e
--- /dev/null
+++ b/lib/hive/commands/setup.rb
@@ -0,0 +1,296 @@
+require "json"
+require "fileutils"
+require "stringio"
+require "hive/config"
+require "hive/paths"
+require "hive/invoked_binary"
+require "hive/commands/setup/backend_prompt"
+require "hive/commands/setup/deps"
+
+module Hive
+  module Commands
+    # `hive setup` — one-shot provisioning + validation of the first-class
+    # LOCAL install surface (Linux systemd-user / macOS launchd). It wires the
+    # sub-pieces in dependency order: backend selection → dependency check →
+    # Hive-owned deps (qmd + web bundle) → daemon service → project enrollment
+    # → web service. Every step is idempotent; external agent CLIs are
+    # diagnosed (never installed/authenticated), and each failure carries the
+    # exact fix command.
+    #
+    # Collaborators (deps / web_bundle / runner / health_probe) are injectable
+    # so the orchestration order is unit-testable without real subprocesses.
+    class Setup
+      # How long the web health probe keeps retrying connection failures
+      # before giving up. First-run Rails boot + db:prepare after
+      # `hive web install` can exceed a single 5s timeout, so a bounded
+      # retry loop (not a single unbounded-by-retry probe) absorbs it.
+      WEB_HEALTH_PROBE_DEADLINE_SECONDS = 30
+
+      def initialize(json: false, non_interactive: false, project_path: Dir.pwd,
+                     input: $stdin, output: $stderr, summary_io: $stdout,
+                     deps: nil, web_bundle: nil, runner: nil, health_probe: nil)
+        @json = json
+        @non_interactive = non_interactive
+        @project_path = File.expand_path(project_path)
+        @input = input
+        @output = output
+        @summary_io = summary_io
+        @deps = deps
+        @web_bundle = web_bundle
+        @runner = runner || method(:run_real)
+        @health_probe = health_probe || method(:default_health_probe)
+      end
+
+      def call
+        backends = select_backends
+        persist_backends(backends)
+
+        steps = []
+        warnings = []
+
+        dep_results = deps.check
+        steps << { "name" => "deps", "ok" => true, "message" => "checked #{dep_results.size} dependencies" }
+        dep_results.select(&:blocked).each { |r| warnings << "#{r.name}: #{r.fix}" }
+
+        qmd = bootstrap_qmd
+        steps << { "name" => "qmd", "ok" => qmd[:ok], "message" => qmd[:message] }
+
+        bundle = web_bundle.provision
+        steps << { "name" => "web_bundle", "ok" => bundle[:ok], "message" => bundle[:message] }
+
+        daemon = ensure_daemon
+        steps << { "name" => "daemon", "ok" => daemon[:ok], "message" => daemon[:message] }
+
+        enroll = enroll_project
+        steps << { "name" => "enroll", "ok" => enroll[:ok], "message" => enroll[:message] }
+
+        web = ensure_web_service
+        steps << { "name" => "web", "ok" => web[:ok], "message" => web[:message] }
+
+        # Success = every step passed AND every non-blocked dependency is ok.
+        # Blocked external CLIs (claude/codex/gh) are diagnose-only warnings —
+        # they never gate the local web bring-up.
+        ok = dep_results.all? { |r| r.ok || r.blocked } && steps.all? { |s| s["ok"] }
+
+        if @json
+          puts JSON.generate(
+            hive_setup_envelope(backends, dep_results, steps, warnings, ok)
+          )
+        else
+          print_human_summary(backends, dep_results, steps, warnings, ok)
+        end
+
+        raise Hive::Error, "hive setup incomplete — see the summary above" unless ok
+
+        ok
+      end
+
+      private
+
+      def deps
+        @deps ||= Hive::Commands::Setup::Deps.new
+      end
+
+      def web_bundle
+        @web_bundle ||= begin
+          require "hive/commands/setup/web_bundle"
+          Hive::Commands::Setup::WebBundle.new
+        end
+      end
+
+      def hive_bin
+        @hive_bin ||= (Hive::InvokedBinary.path || "hive")
+      end
+
+      def select_backends
+        input = @non_interactive ? StringIO.new : @input
+        Hive::Commands::Setup::BackendPrompt.new(
+          input: input,
+          output: @output,
+          # In JSON mode the summary line must not land on stdout — it
+          # would corrupt the single-document contract (U3). Route it to
+          # @output ($stderr) instead of @summary_io ($stdout).
+          summary_io: @json ? @output : @summary_io
+        ).collect
+      end
+
+      def persist_backends(backends)
+        Hive::Config.write_global_agents!(backends)
+        backends
+      end
+
+      # `qmd` (the Hive-managed wiki indexer) is bootstrapped into Hive's own
+      # data prefix, mirroring install.sh's managed npm install contract. Never
+      # touches the user's global npm prefix or authenticates anything.
+      def bootstrap_qmd
+        qmd_home = File.join(Hive::Paths.data_home, "qmd")
+        qmd_bin = File.join(qmd_home, "bin", "qmd")
+        return { ok: true, message: "qmd already installed" } if File.executable?(qmd_bin)
+
+        _out, npm_ok = @runner.call(%w[npm --version])
+        return { ok: false, message: "npm missing — install Node.js/npm, then re-run hive setup" } unless npm_ok
+
+        FileUtils.mkdir_p(qmd_home)
+        package = ENV["HIVE_QMD_NPM_PACKAGE"] || "@tobilu/qmd"
+        _out, ok = @runner.call([ "npm", "install", "--global", "--prefix", qmd_home,
+                                  "--no-audit", "--no-fund", package ])
+        return { ok: false, message: "qmd install failed; run: npm install --global --prefix #{qmd_home} #{package}" } unless ok
+
+        link_qmd(qmd_home, qmd_bin)
+        { ok: true, message: "qmd installed to #{qmd_home}" }
+      end
+
+      def link_qmd(qmd_home, qmd_bin)
+        bin_dir = Hive::Paths.bin_home
+        FileUtils.mkdir_p(bin_dir)
+        link = File.join(bin_dir, "qmd")
+        FileUtils.ln_sf(qmd_bin, link)
+      rescue StandardError
+        nil
+      end
+
+      def ensure_daemon
+        _out, install_ok = @runner.call([ hive_bin, "daemon", "install", "--force" ])
+        return { ok: false, message: "hive daemon install --force failed" } unless install_ok
+
+        # `hive daemon status --json` exits 1 when the daemon is not running
+        # but STILL emits its JSON envelope on stdout, so the exit code is
+        # not a command-failure signal. Parse the envelope unconditionally:
+        # a systemd-less host (install → autostart_unavailable) or a restart
+        # race right after `install --force` must not fail setup just because
+        # the daemon briefly reports "not running". A truly broken status
+        # command yields invalid JSON and fails below.
+        status_out, = @runner.call([ hive_bin, "daemon", "status", "--json" ])
+
+        begin
+          payload = JSON.parse(status_out)
+        rescue JSON::ParserError
+          return { ok: false, message: "hive daemon status returned invalid JSON" }
+        end
+
+        # U5 consistency guard: false = drifted binary/version, true =
+        # verified consistent, nil = the probe could not verify (e.g. /proc
+        # and ps both unavailable). nil must NOT be reported as pass —
+        # unverifiable drift is not "consistent".
+        case payload["consistent"]
+        when false
+          return { ok: false, message: "daemon binary is inconsistent with the CLI; run `hive daemon install --force`" }
+        when nil
+          return { ok: false, message: "daemon consistency could not be verified; run `hive daemon status --json` to inspect" }
+        end
+
+        { ok: true, message: "daemon service installed and consistent" }
+      end
+
+      def enroll_project
+        registered = Hive::Config.registered_projects.any? do |p|
+          File.expand_path(p["path"]) == @project_path
+        end
+
+        if registered
+          name = Hive::Config.registered_projects.find { |p| File.expand_path(p["path"]) == @project_path }["name"]
+          _out, ok = @runner.call([ hive_bin, "daemon", "enable", name ])
+          return { ok: false, message: "hive daemon enable #{name} failed" } unless ok
+
+          { ok: true, message: "enrolled #{name} in the daemon" }
+        else
+          _out, ok = @runner.call([ hive_bin, "init", @project_path, "--force" ])
+          return { ok: false, message: "hive init #{@project_path} failed" } unless ok
+
+          { ok: true, message: "initialized #{@project_path}" }
+        end
+      end
+
+      def ensure_web_service
+        _out, install_ok = @runner.call([ hive_bin, "web", "install" ])
+        return { ok: false, message: "hive web install failed" } unless install_ok
+
+        # Persist the local loopback web contract (U1/R4). `hive web install`
+        # (the subprocess above) writes it too, but the in-process write is
+        # what keeps this observable when the runner is injected/stubbed and
+        # guarantees a fresh `hive setup` never leaves web.auth_mode at the
+        # "owner" default.
+        Hive::Config.write_local_web_loopback!
+
+        ok, message = @health_probe.call
+        { ok: ok, message: message }
+      end
+
+      # Bounded HTTP probe with retry: open_timeout caps the TCP connect and
+      # read_timeout caps the response wait, so a hung web server (or a port
+      # that accepts but never answers) cannot hang `hive setup`
+      # indefinitely. The probe targets the RESOLVED web_url (so a
+      # non-default configured port is probed too, not the hardcoded
+      # 127.0.0.1:4567), and retries connection failures up to
+      # WEB_HEALTH_PROBE_DEADLINE_SECONDS because first-run Rails boot +
+      # db:prepare can exceed a single 5s timeout.
+      def default_health_probe
+        require "net/http"
+        base = web_url
+        uri = URI("#{base}/health?deep=1")
+
+        deadline = Time.now + WEB_HEALTH_PROBE_DEADLINE_SECONDS
+        last_error = nil
+        loop do
+          begin
+            res = Net::HTTP.start(uri.host, uri.port, open_timeout: 5, read_timeout: 5) do |http|
+              http.request(Net::HTTP::Get.new(uri))
+            end
+            ok = res.is_a?(Net::HTTPSuccess)
+            return [ ok, ok ? "web health OK at #{base}" : "web health returned #{res.code}" ]
+          rescue StandardError => e
+            last_error = e
+          end
+          break if Time.now >= deadline
+
+          sleep 1
+        end
+
+        [ false, "web health probe failed: #{last_error ? "#{last_error.class}: #{last_error.message}" : 'no response'}" ]
+      end
+
+      def run_real(argv)
+        require "open3"
+        out, _err, status = Open3.capture3(*argv)
+        [ out, status.success? ]
+      rescue Errno::ENOENT, Errno::EACCES
+        [ "", false ]
+      end
+
+      def web_url
+        cfg = Hive::Config.load_global_web
+        "http://#{cfg.fetch('bind')}:#{cfg.fetch('port')}"
+      rescue Hive::ConfigError
+        "http://127.0.0.1:4567"
+      end
+
+      def hive_setup_envelope(backends, dep_results, steps, warnings, ok)
+        {
+          "schema" => "hive-setup",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-setup"),
+          "ok" => ok,
+          "backends" => backends,
+          "deps" => dep_results.map(&:to_h),
+          "steps" => steps,
+          "web_url" => web_url,
+          "warnings" => warnings
+        }
+      end
+
+      def print_human_summary(backends, dep_results, steps, warnings, ok)
+        @summary_io.puts "hive setup: backends = #{backends.join(', ')}"
+        dep_results.each do |r|
+          mark = r.ok ? "ok" : (r.blocked ? "blocked" : "missing")
+          line = "  #{mark.ljust(7)} #{r.name.ljust(9)} #{r.message}"
+          line += "  (#{r.fix})" if r.fix
+          @summary_io.puts line
+        end
+        steps.each do |s|
+          @summary_io.puts "  #{s['ok'] ? 'ok' : 'FAILED'.ljust(6)} #{s['name'].ljust(11)} #{s['message']}"
+        end
+        warnings.each { |w| @summary_io.puts "  warn: #{w}" }
+        @summary_io.puts(ok ? "hive setup: complete — web UI at #{web_url}" : "hive setup: incomplete")
+      end
+    end
+  end
+end
